VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPopupWindow"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"PopupWindow"

'********************************************************************************************
'    clsPopupWindow -   
'********************************************************************************************
'
' :
'           Init(ByVal fhwnd As Long, ByVal pwWidth As Long, _
'                ByVal pwHeight As Long, ByVal fDefaultPosition As Long, _
'                ByVal dFB As Long) -     
'                                        
'                fhwnd -  
'                pwWidth -  
'                pwHeight -  
'                fDefaultPosition -      
'
'           PopupWindow(ByVal fhwnd As Long, ByVal dEvent As Long, _
'                       ByVal dValue As Byte) As Long
'
'                fhwnd -  
'                dEven -  (\)
'                dValue -   (0...255)
'
'           OnSound(ByVal ApphInstance As Long, ByVal dId As Long)- 
'                          WAV  .
'
'                  ApphInstance -  hModule 
'                  dId -  
'
'************************************************************************************
'  :
'
'           fStartLeft As Long    -  X  
'           fStopLeft As Long     -  X  
'           fStartTop As Long     -  Y  
'           fStopTop As Long      -  Y  
'           fBase As Long         -   () 
'           fHeight As Long       -  
'           fWidth As Long        -  
'           varIsHide             -  
'           XScale                -  screen.TwipsPerPixelX
'           YScale                -  screen.TwipsPerPixelY
'
'************************************************************************************
'
'
'
'     dll:
'                       User32.dll; Wimm.dll;
'
'  :              v. 1.0
'  :           Windows XP Professional SP2, VB 6.0 Enterprise Edition
'   :       15.10.2007 .
'  :                 
'  ICQ:                 321599507
'  E-Mail:              lsd_inside@mail.ru
'
'
'
'
Option Explicit

Private Declare Function BringWindowToTop Lib "user32" (ByVal Hwnd As Long) As Long
Private Declare Function PlaySound Lib "Winmm" Alias "PlaySoundA" (ByVal lpszName As Long, ByVal hModule As Long, ByVal dwFlags As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal Hwnd As Long, ByVal crKey As Long, ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal Hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal Hwnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

Private fStartLeft As Long               '
Private fStopLeft As Long                '
Private fStartTop As Long                '
Private fStopTop As Long                 '
Private fBase As Long                    '
Private fHeight As Long                  '
Private fWidth As Long                   '
Private XScale As Long                   '
Private YScale As Long                   '

Private varIsHide As Boolean

Private Const LWA_ALPHA = &H2
Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_LAYERED = &H80000
Private Const SND_ASYNC = &H1            '  
Private Const SND_RESOURCE = &H40004     '   
                              
                              '     
Private Const PW_LEFT = 0                ' 
Private Const PW_RIGHT = 1               ' 
Private Const PW_TOP = 2                 ' 
Private Const PW_BOTTOM = 3              ' 
Private Const PW_HIDE = 100              '  
Private Const PW_SHOW = 101              '  

Private Type POINTAPI
    X As Long
    Y As Long
End Type

 


Public Function Init(ByVal fhwnd As Long, ByVal pwWidth As Long, ByVal pwHeight As Long, ByVal fDefaultPosition As Long, ByVal dFB As Long)
    Dim ret As Long
      
      ret = GetWindowLong(fhwnd, GWL_EXSTYLE)
      ret = ret Or WS_EX_LAYERED
       SetWindowLong fhwnd, GWL_EXSTYLE, ret
        BringWindowToTop (fhwnd)
       
       fBase = dFB
       fWidth = pwWidth
       fHeight = pwHeight
       
       XScale = Screen.TwipsPerPixelX
       YScale = Screen.TwipsPerPixelY
       
       Select Case dFB
         
         Case PW_LEFT
           fStartLeft = 0
           fStopLeft = -pwWidth
           fStartTop = fDefaultPosition
           fStopTop = fStartTop
        Case PW_RIGHT
           fStartLeft = Screen.Width - pwWidth
           fStopLeft = Screen.Width
           fStartTop = fDefaultPosition
           fStopTop = fStartTop
               
        Case PW_TOP
           fStartTop = 0
           fStopTop = fStartTop - pwHeight '
           fStartLeft = fDefaultPosition
           fStopLeft = fStartLeft
        
        Case PW_BOTTOM
           fStartTop = Screen.Height - pwHeight '
           fStopTop = Screen.Height
           fStartLeft = fDefaultPosition
           fStopLeft = fStartLeft
             
       End Select
           
           MoveWindow fhwnd, fStopLeft, fStopTop, pwWidth, pwHeight, 1


End Function

Public Function PopupWindow(ByVal fhwnd As Long, ByVal dEvent As Long, ByVal dValue As Long) As Long
    Dim IntervalX As Long
    Dim IntervalY As Long
    Dim Value As Integer
   
    
    IntervalX = fWidth \ 256
    IntervalY = fHeight \ 256
     
      Select Case fBase
      
        Case PW_LEFT
           If dEvent = PW_HIDE Then
               MoveForm fhwnd, fHeight, fWidth, fStartTop, fStartLeft - IntervalX * dValue
               SetAlfaBlendValue fhwnd, 255 - dValue
           ElseIf dEvent = PW_SHOW Then
               MoveForm fhwnd, fHeight, fWidth, fStopTop, fStopLeft + IntervalX * dValue
               SetAlfaBlendValue fhwnd, dValue
           End If
        Case PW_RIGHT
           If dEvent = PW_HIDE Then
               MoveForm fhwnd, fHeight, fWidth, fStartTop, fStartLeft + IntervalX * dValue
               SetAlfaBlendValue fhwnd, 255 - dValue
           ElseIf dEvent = PW_SHOW Then
               MoveForm fhwnd, fHeight, fWidth, fStopTop, fStopLeft - IntervalX * dValue
               SetAlfaBlendValue fhwnd, dValue
           End If
        Case PW_TOP
           If dEvent = PW_HIDE Then
               MoveForm fhwnd, fHeight, fWidth, fStartTop - IntervalY * dValue, fStartLeft
               SetAlfaBlendValue fhwnd, 255 - dValue
           ElseIf dEvent = PW_SHOW Then
               MoveForm fhwnd, fHeight, fWidth, fStopTop + IntervalY * dValue, fStopLeft
               SetAlfaBlendValue fhwnd, dValue
           End If
        Case PW_BOTTOM
           If dEvent = PW_HIDE Then
               MoveForm fhwnd, fHeight, fWidth, fStartTop + IntervalY * dValue, fStartLeft
               SetAlfaBlendValue fhwnd, 255 - dValue
           ElseIf dEvent = PW_SHOW Then
               MoveForm fhwnd, fHeight, fWidth, fStopTop - IntervalY * dValue, fStopLeft
               SetAlfaBlendValue fhwnd, dValue
           End If
      End Select
    
End Function

Private Function MoveForm(ByVal fhwnd As Long, ByVal fHeigth As Long, ByVal fWidth As Long, ByVal fTop As Long, ByVal fLeft As Long)
 
 Dim X As Long
 Dim w As Long
 Dim h As Long
 Dim Y As Long
   
 X = fLeft \ XScale
 w = fWidth \ XScale
 h = fHeigth \ YScale
 Y = fTop \ YScale
 MoveWindow fhwnd, X, Y, w, h, 1
End Function

Private Function SetAlfaBlendValue(ByVal fhwnd As Long, ByVal dValue As Byte)
  '   .
  SetLayeredWindowAttributes fhwnd, 0, dValue, LWA_ALPHA
End Function

Public Function OnSound(ByVal ApphInstance As Long, ByVal dId As Long)
 '  
 PlaySound dId, ApphInstance, SND_ASYNC Or SND_RESOURCE

End Function

 
